package com.framework.mvvm.model.db.dao

import androidx.room.*
import com.framework.mvvm.model.db.entity.dict.InfosConfigEntity

/**
 * 表 infos_config Dao
 */
@Dao
interface InfosConfigDao {
    @Query("select * from infos_config")
    suspend fun getConfigs(): List<InfosConfigEntity>

    @Query("select * from infos_config where id = :id")
    suspend fun getConfigById(id: String): InfosConfigEntity

    @Query("select * from infos_config where obj_type = :type")
    suspend fun getConfigByObjType(type: String): List<InfosConfigEntity>

    @Query("select * from infos_config where obj_type = :type and class_code =:code")
    suspend fun getConfigByEquipCode(type: String, code: String): List<InfosConfigEntity>

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    suspend fun insConfig(vararg config: InfosConfigEntity)

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    suspend fun insConfigs(configs: List<InfosConfigEntity>)

    @Delete
    suspend fun delConfig(config: InfosConfigEntity)
}