package com.framework.mvvm.model.vo

import com.framework.mvvm.model.db.entity.task.*

/**
 * Building 对象
 */
data class Building(
    val buildingId: String,
    val jobSpace: List<JobSpaceEntity>?,
    val objects: List<ObjectEntity>?,
    val file: List<FileEntity>?,
    val qrCode: List<QrCodeEntity>?,
    val relations: List<RelationEntity>?,
    val problemArch: List<ProblemArchEntity>?,
    val problemEquip: List<ProblemEquipEntity>?,
    val pipes: List<PipeEntity>?,
    val areas: List<ServeAreaEntity>?,
    val bdtpDownloadTs: Long = 0L,   // bdtp数据库下载同步时间戳
    val admDownloadTs: Long = 0L,     // adm数据库下载同步时间戳
    val uploadJobId: String = ""
)
